# v1.1 Release Note

### v1.1.3 Release Note
1. support of getAllLogs and GetActPoolActions APIs
2. `ioctl` support HD wallet, `ioctl contract` improvement
3. bug fixes and test coverage improved

### v1.1.2 Release Note
1. Improve transaction log APIs
2. fixed issue where staking protocol account data height is not accurate
3. Add configuration to allow node to split chain db file and apply data compression using Snappy on chain db data
In order to turn the compression on, you will need to set the following setting in your config.yaml:
```
db:
  v2BlocksToSplitDB: 1000000
```
1,000,000 is the maximum number of blocks a splitted chain db file may contain(the estimated size of resulting chain db file is about 4GB). You can change to another number that fits your needs best.


### v1.1.1 Release Note
1. Improve node stability on poor blocksync request handling
2. Fix a nill ptr issue on blockmeta API when gateway is turned off


### v1.1.0 Release Note

1. Support of Reclaim Buckets
One can now transfer the ownership of a bucket that is previously staked by a private key in Ethereum hardware wallet to another designated IoTeX address
- One signs a message using the hardware wallet to prove one's ownership of the original bucket and designation of a new address, and upon protocol's verification, that bucket will be transferred to the new address on IoTeX blockchain. 
- To use it, go to https://member.iotex.io/reclaim-bucket/, or download the latest ioctl tool, type in "ioctl stake2 reclaim", and follow the instruction.

2. New Transaction Log
One important aspect of blockchain is record of all transactions involving token change-hand for accounting/auditing purpose. This release has added this capability by providing two new gRPC APIs as below. Please refer to https://github.com/iotexproject/iotex-proto/tree/v0.4.0 for details about latest API.
- "GetTransactionLogByActionHash": query transaction logs by action hash
- "GetTransactionLogByBlockHeight": query transaction logs by block height

3. Visibility about Staking
The protocol and the latest ioctl tool provide support of visibility of the native staking. The new commands can be used as below:
- "ioctl account balance io000000000000000000000000stakingprotocol": this shows the total amount of staked token
- "ioctl account balance io0000000000000000000000rewardingprotocol": this shows the total amount of available rewards

4. Optimize Docker Image
v1.1.0 brings more lean and secure binaries by switching the docker base image to Alpine, a lightweight and secure Linux distribution. As a result, the image size reduced from 1.99GB to only 93.9MB, which enables a faster download and easier installation.

5. Misc
- Upgrade of Protobuf
- Improvement of ioctl
- Improve the performance of trie
- Bug fixes
