# v1.3 Release Note

## v1.3.0 Release Note
**Note that v1.3.0 has a hardfork, which will be activated at block height
12,289,321 (ETA is 7/22/2021 around 2pm UTC-7:00) on IoTeX mainnet.**
1. v1.3 has upgraded to latest EVM version so user can confidently deploy their
DApps to IoTeX blockchain. This EVM upgrade supports the ChainID opcode to
prevent relay attacks and enable cross-chain transparency, and has optimized gas
costs of certain opcodes, especially privacy and zk computations. See below for
details
2. Optimized block sync strategy to make it more robust
3. Fixed a bug that API query needs to wait a little while to return the latest
committed block
4. Fixed a bug that node stops working after network connectivity is lost. Now
the node can detect the network loss/reconnect event, and automatically resume
working after network connectivity is restored

## EVM upgrade
Starting v1.3 the IoTeX blockchain supports EVM Istanbul, which brings upgrades
that improve denial-of-service attack resilience, and adjust gas costs for EVM
storage and zk-SNARKs and zk-STARKs, allowing privacy applications based on
SNARK and STARK to scale at a cheaper cost.

Here's the list of EIP adopted in the Istanbul upgrade:

- [EIP-152](https://eips.ethereum.org/EIPS/eip-152) -- precompiled Blake2b to
facilitate Zcash
- [EIP-1108](https://eips.ethereum.org/EIPS/eip-1108) -- better bn256 library
for faster EC computation and reduced gas cost
- [EIP-1344](https://eips.ethereum.org/EIPS/eip-1344) -- adds the CHAINID opcode
to return current chain's EIP-155 unique identifier inside smart contract
- [EIP-1884](https://eips.ethereum.org/EIPS/eip-1884) -- repricing for trie-size
-dependent opcodes
- [EIP-2028](https://eips.ethereum.org/EIPS/eip-2028) -- transaction data gas cost
reduction
- [EIP-2200](https://eips.ethereum.org/EIPS/eip-2200) -- cost reduction of storage
in the EVM

### Gas cost change
Here's a summary of gas cost change as a result of these EIPs

| Precompiled contract | Address | Current gas cost | Updated gas cost |
| --- | --- | --- | --- |
| ECADD | 0x06 | 500 | 150 |
| ECMUL | 0x07 | 40000 | 6000 |
| Pairing check | 0x08 | 80000*k* + 100000 | 34000*k* + 45000 |

*k* is the number of pairings being computed

| Opcode | Address | Current gas cost | Updated gas cost |
| --- | --- | --- | --- |
| SLOAD | 0x54 | 200 | 800 |
| BALANCE | 0x31 | 400 | 700 |
| EXTCODEHASH | 0x3F | 400 | 700 |
| SELFBALANCE | 0x47 | n/a | 5 |
| Calldata | n/a | 68 per byte | 16 per byte |

