# v1.6 Release Note

## v1.6.0 Release Note
**Note that v1.6.0 has a hardfork, which will be activated at block height
13,979,161 (ETA is 10/28/2021 around 11pm UTC) on IoTeX mainnet.**
1. Added API tracing functionality, which enables measuring and visualizing the
break-down of API call timing. We'll work on API performance improvement based
on the observability this tool provides in future releases
2. Exposed gRPC health check point in the API server
3. Fixed contract read issue for certain smart contracts we've seen earlier
4. ioctl tool can export private key from HDWallet now

## v1.6.1 Release Note
1. Separated the p2p network for Mainnet and Testnet, this reduces the network
traffic interference and noise between 2 networks
2. Rectified transaction error message to be compatible with chainlink
3. API service added ReadContractStorage() interface

## v1.6.2 Release Note
1. fixed EVM calldata dump issue

## v1.6.3 Release Note
1. Implemented HTTP server to support [Ethereum's JSON-RPC protocol](https://eth.wiki/json-rpc/API) 
inside iotex-core (this removes the need of intermediate Babel bridge/service)
2. Added `eth_getStorageAt` method
3. Instrumented tracing to measure timing on critical code path
4. Enabled EVM tracing to collect calling stacks inside EVM
5. Performance improvement of ActPool
6. Enabled log rotate
7. Corrected nested context usage in transaction processing loop

## v1.6.4 Release Note
1. Fixed certain hardcode values in original babel service ([#3038](https://github.com/iotexproject/iotex-core/pull/3038))
2. Correctly handle array in web3 request ([#3050](https://github.com/iotexproject/iotex-core/pull/3050))
3. Added more tracing for slow API ([#3057](https://github.com/iotexproject/iotex-core/pull/3057))
4. Fixed log query (with large block range) causing high memory usage ([#3062](https://github.com/iotexproject/iotex-core/pull/3062))
5. Added gasFee info into GetActions() API ([#3063](https://github.com/iotexproject/iotex-core/pull/3063))
