---
Postmortem ID: 6
Title: Double execution gas before Pacific
Author: Yutong Pei <yutong@iotex.com>
Status: Mitigated
Created: 2020-07-15
Updated: 2020-07-15
---

This is a record keeping for an issue we had before 2019-06-11 on the mainnet chain.

# Abstract

Before Pacific height(432001), execution action pay double amout of gas, only half of the double amount go to rewarding pool, other half got burned.

# Cause

This was a code bug which subtract sender gas twice for execution. Only execution had this issue at that time, transfer didn't. Because in the old transfer code, this is what happened:

1. transfer protocol read out sender balance from statedb into memory as inMemSenderA
2. transfer protocol sub inMemSenderA's gas fee
3. rewarding protocol read out sender balance from statedb into memory as inMemSenderB
4. rewarding protocol sub inMemSenderB's gas fee, add gas fee to rewarding pool. Then store both in mem state to statedb.
5. transfer protocol sub inMemSenderA with transfer token amount, then store inMemSenderA to statedb which overwrote the sender state rewarding protocol had stored in previous step.
6. In the end we have sender (init balance - gas - sent amount), rewarding pool (init balance + gas) in statedb which is correct.

# Solution
Fixed in https://github.com/iotexproject/iotex-core/pull/1141.

Deployed and activated on mainnet after Pacific height(432001) at 2019-06-11.
