---
Postmortem ID: 3
Title: Mainnet Stuck at Height 1641780
Author: Raullen <raullen@iotex.io>
Created: 2019-10-30
Updated: 2019-10-30
---

# Abstract

In ~7am PDT of Oct. 30 2019, Mainnet stuck at height 1641780. Protocol dev quicky figured out the root cause (more than 1/3 delegates were not upgraded to 0.9.1 or 0.9.2). After notifying delegates and having them upgrading their nodes, chain operation came back round ~11am PDT of Oct. 30 2019. 

# Impact
Chain stalled for about 4 hours and no damage has been reported so far.

# Root Cause
More than 1/3 delegates were not upgraded to 0.9.1 or 0.9.2 correctly:
1. They have not upgraded the binary even though IoTeX Foundation made the official announcement about 3 weeks ago.
2. They have not upgrade genesis.yaml when upgrading to 0.9.1 (or 0.9.2), i.e., `nativeStakingContractAddress: io1xpq62aw85uqzrccg9y5hnryv8ld2nkpycc3gza` is not in the genesis.yaml which causes the node's ignorance of the delegates status. `curl https://raw.githubusercontent.com/iotexproject/iotex-bootstrap/master/genesis_mainnet.yaml > $IOTEX_HOME/etc/genesis.yaml` and restart the docker address this issue.


# Mitigation
IoTeX Foundation outreached to these delegates and helped them to upgrade to 0.9.1/2; and the chain started to operate right after enough delegates come back online. Although there are stragllers still, the number of them is less than 1/3 of delegates. IoTeX Foundation will keep outreaching to the stragllers. 

After ~12 hours, all delegates have upgraded.

# Next Steps
**Better Communication With Delegates***
1. Collect valid contact information from all delegates.

**Easier Upgrade***
1. Tie config/genensis yaml versions with iotex-core binary - https://github.com/iotexproject/iotex-core/issues/1585
2. Develope a cli tool to validate node status - https://github.com/iotexproject/iotex-core/issues/1590

**Effective Governance***
1. Make more status of nodes available on member.iotex.io - https://github.com/iotexproject/web-bp/issues/1391
2. Slashing of delegates who failed to produce blocks (above a threshold) and so on. The design of slashing is in progress.
3. The protocol rewards the first (perhaps) 24 delegates who upgrade.
4. More decentralized and more delegates.
