---
Postmortem ID: 4
Title: Mainnet native staking not present in voting total result
Author: Yutong <Yutong@iotex.io>
Created: 2020-1-29
Updated: 2020-1-29
---

# Abstract

Since 01/23/2020 @ 11:53pm (UTC) epoch 6593, native stakings are not included in total votes in vote counting, only stakings on Ethereum are counted in.

# Impact
For each epoch, the epoch rewards are distributed to all delegates participating in this epoch's block creation, according to the percentage of their total votes.

Now IoTeX staking in native contract are not counted in delegates’ total votes, this caused the percentage to be calculated inaccurately, and hence voters/delegates are not rewarded correctly for the affected epochs.

# Root Cause
Native staking buckets are stored in a smart contract on iotex mainnet. The gas limit to read buckets data from the contract is set to 1,000,000. 1,000,000 is enough to read out buckets data when the total number of buckets are small, but not enough when the number of buckets grows to a certain threshold. On epoch 6593, we had more than 120 buckets in contract, and with 1,000,000 gas limit we are not able to read out the buckets data at all, so we end up with read out empty data.

# Timeline (PST)
01/23/2020 4AM	Chain was unable to read native staking data from native staking contract

01/28/2020 11AM	IoTeXLab(Simone) reached out to report that their native staking votes are not reflected in their rewards

01/28/2020 11AM	Protocol dev started the investigation

01/29/2020 5PM	Protocol dev identified the root cause

01/29/2020 5PM	Protocol dev began working on a patch to fix the issue

01/31/2020 3PM	Fix was merged in and a new version v0.10.2 was released

02/10/2020 3PM  Fix takes effective on mainnet

# Mitigation
A new version v0.10.2 is targeting to fix the issue. In this version, the gas limit to read native staking buckets is increased to 10 times as before (10,000,000). End-to-end test which reads 1200 buckets is also introduced to cover this case, and we verified on mainnet the fix can read out staking buckets correctly.

Protocol dev team is working on a tool to re-count the correct total votes (and percentage) for the affected epochs (from 6593 to when the fix takes place), and re-calculate the correct amount of rewards each delegate should have received. The difference amount will be paid to affected delegates shortly after the fix takes place.

# Next Steps
**Native staking with native go code ***
Native implementation of staking will have a much more predictable behavior, and thanks to it’s high performance, we can also simplify logic and avoid pagination.
**Better testing on edge conditions***
We thought we tested native staking pretty well, but we were wrong, we didn’t test enough. If we did test buckets with the number of pagination size, we could find the issue in first place. In future, we need to make sure we no only test end to end but also test corner to corner.
