---
Postmortem ID: 5
Title: Reward Pool Drained
Author: Raullen Chai <raullen@iotex.com>
Status: Mitigated
Created: 2020-03-17
Updated: 2020-03-17
---


# Abstract

Starting epoch 7870, the action for granting rewards to delegates begin to fail with status = 0 and empty log.
Block rewards are missing from height 3849915 to 3856812. Epoch rewards and foundation bonus are missing from epoch 7870 to 7879.

# Cause

The reward pool has run out of the initial balance of 200,000,000 IOTX, which accounts for 2% of the total supply.

# Solution

The reward pool has been refilled with 1,000,020,000 IOTX, which accounts for 10% of the total supply.

The missing coins have been issued to delegates in tx https://www.iotexscan.io/action/e81313d825d62759a5e5cd4257e9296bd0dcc62699f2fd8bddf9ff208fe2076d.

The missing rewards have been calculated and the details are shown below:

| Delegate Name | Reward Address                            | Block Rewards | Epoch Rewards  | Foundation Bonus | Total          |
|---------------|-------------------------------------------|---------------|----------------|------------------|----------------|
| airfoil       | io1357e46wkunknfqz2u8n5vu9ewdy9qqce6aq0yw | 1344          | 4476.745478    | 800              | 6620.745478    |
| alphacoin     | io1aauj5rdegpzgmvrlpp3fgwn78utjcdlgrnk58x | 0             | 77.89823442    | 0                | 77.89823442    |
| blackpool     | io1mrnsu5pfu56narfkqdja2fe76v5ucjgckh38ay | 0             | 10.79876958    | 0                | 10.79876958    |
| blockboost    | io1enflh9v4hchwwlrw557h2tvjw6rup9mpjr0ncy | 1576          | 2890.873955    | 800              | 5266.873955    |
| blockfolio    | io13tynzqmr7s7f378pmvcunrrjtucp0huv44mjvt | 1440          | 3332.708956    | 800              | 5572.708956    |
| capitmu       | io1yjjqtktt5yh54zcum4dfj2xh4r6xatq8p8nflv | 1784          | 2996.000311    | 800              | 5580.000311    |
| citex2018     | io10g5k7nj9ryxzpymms75fhjweqhyqwp4ts9p0l8 | 0             | 641.8030987    | 0                | 641.8030987    |
| cobo          | io1pxjfyy24s5lkxj60y43r99zr90khdx7cw4pfjz | 0             | 1989.645017    | 0                | 1989.645017    |
| coingecko     | io1dfv45vq9vx69uwz660nqaqt9q6pv5j2496dq27 | 2056          | 2493.276437    | 800              | 5349.276437    |
| consensusnet  | io1p6xzyl5z4p5z43406l0rqypqdk2zgv56wf8wjp | 0             | 1402.134981    | 0                | 1402.134981    |
| coredev       | io12mgttmfa2ffn9uqvn0yn37f4nz43d248l2ga85 | 1576          | 10747.5005     | 800              | 13123.5005     |
| cpc           | io1066kus4vlyvk0ljql39fzwqw0k22h7j8wmef3n | 1000          | 5031.964569    | 800              | 6831.964569    |
| draperdragon  | io177hkhq2cfat82u2kdh2zkpnwtl4v2uht3843ch | 1096          | 3569.934319    | 800              | 5465.934319    |
| droute        | io12mgttmfa2ffn9uqvn0yn37f4nz43d248l2ga85 | 2008          | 8705.957782    | 800              | 11513.95778    |
| ducapital     | io1lqqhg6ge2c9a0wyckwfdtgh29fnufzz95xxd23 | 1536          | 4257.912808    | 800              | 6593.912808    |
| elitex        | io15jlmpax9azjpde4cl3xjzfp08pzzsqsstnr43g | 1096          | 3246.412886    | 800              | 5142.412886    |
| enlightiv     | io12mgttmfa2ffn9uqvn0yn37f4nz43d248l2ga85 | 1240          | 7022.071661    | 800              | 9062.071661    |
| everstake     | io1krwn82flyvqsxaw5ekur9mxkzw5vrlp96t8elx | 0             | 230.9660637    | 0                | 230.9660637    |
| gamefantasy#  | io12mgttmfa2ffn9uqvn0yn37f4nz43d248l2ga85 | 1336          | 5993.191962    | 800              | 8129.191962    |
| hashbuy       | io18tnk59jqdjgpdzz4hq4dl0dwwjkv7gg20fygqn | 1824          | 5051.345693    | 800              | 7675.345693    |
| hashquark     | io12mgttmfa2ffn9uqvn0yn37f4nz43d248l2ga85 | 816           | 3189.457595    | 800              | 4805.457595    |
| hofancrypto   | io13672hgsdr7d8nu5jndyageygel3r5nwyzqwlhl | 1824          | 3577.492676    | 800              | 6201.492676    |
| hotbit        | io12mgttmfa2ffn9uqvn0yn37f4nz43d248l2ga85 | 1440          | 5939.809473    | 800              | 8179.809473    |
| huobiwallet   | io12mgttmfa2ffn9uqvn0yn37f4nz43d248l2ga85 | 1824          | 6309.005428    | 800              | 8933.005428    |
| infstones     | io1w7enh0vv87uw9rt732z089nq6652dradk30vlu | 0             | 1827.040432    | 0                | 1827.040432    |
| iosg          | io12mgttmfa2ffn9uqvn0yn37f4nz43d248l2ga85 | 1584          | 5767.378783    | 800              | 8151.378783    |
| iotask        | io12aymfg8gp2kjeugwdjd50lv3v7wh23v4qgm3x4 | 0             | 1432.891414    | 0                | 1432.891414    |
| iotexcore     | io1n9x6np9uwsr0g6gac63su4gzwzcgy2ct704nmn | 0             | 3674.542294    | 800              | 4474.542294    |
| iotexgeeks    | io1g2hsz6v68v4rqjjyqkywms605kepspejj3esxg | 0             | 1445.923611    | 0                | 1445.923611    |
| iotexicu      | io1fzfl62gqj77lgnnw9jxvyycz0tvvn5ak9vaqp3 | 0             | 303.5884177    | 0                | 303.5884177    |
| iotexlab      | io1rpavnz36r7wp9zs4m33qrmmwkqhtpzv03hyr9t | 1968          | 3754.532001    | 800              | 6522.532001    |
| iotexmainnet  | io1mrm4gchhdwtp4ulyd8yqus9s6tgn5nygtswjxx | 0             | 6.618465661    | 0                | 6.618465661    |
| iotexteam     | io1yycphrnxfwn32c0r8er4an5zvlnv8rwheslln9 | 1824          | 4637.092223    | 800              | 7261.092223    |
| iotexunion    | io1lqdgkgjzw2syl7a5w6a0zk6mg04ftdl0cxky0w | 0             | 666.3224318    | 0                | 666.3224318    |
| iotxplorerio  | io1fsrkpzrt6juvkuermz6dd2ng3a044uda6ywu8l | 2056          | 4575.072217    | 800              | 7431.072217    |
| keys          | io1f6vcjkudxnfdzv4v66sjljpych38h7387ynwvw | 0             | 278.0944356    | 0                | 278.0944356    |
| lanhu         | io1jepce667yfux0z4xt9m6tp62fy3qs0h89qkhd8 | 0             | 1.970779784    | 0                | 1.970779784    |
| laomao        | io1464yt9pmty64dlun95kvuvdtr2n3wf2cx4t9p2 | 1296          | 5756.914993    | 800              | 7852.914993    |
| link          | io1qza3y0dwclkyputfd2vtl0qy75yjjxnzefhmj0 | 0             | 7.366019873    | 0                | 7.366019873    |
| longz         | io12mgttmfa2ffn9uqvn0yn37f4nz43d248l2ga85 | 1576          | 3888.568421    | 800              | 6264.568421    |
| metanyx       | io12mgttmfa2ffn9uqvn0yn37f4nz43d248l2ga85 | 1480          | 7103.558311    | 800              | 9383.558311    |
| meter         | io1nppj7tfh68cdwy58j379m8vytahwtnqhp9k7e4 | 0             | 0.009199492992 | 0                | 0.009199492992 |
| mrtrump       | io1uxmfklwyqvjrxwpcljgqq759yy8xv26g5pt75v | 1008          | 3818.547841    | 800              | 5626.547841    |
| nodeasy       | io1gtwkgu7458w20as7ttsp24cdga90dmpntq2rwr | 0             | 211.6952849    | 0                | 211.6952849    |
| pnp           | io1mrdqgmxs78z2z9uh7nxdy5znqq464uq3ytep99 | 1296          | 4176.192885    | 800              | 6272.192885    |
| preangel      | io13v4pnjhfhxdynpq0uhwv2lmu3a5uvwtclls63p | 1488          | 2979.424404    | 800              | 5267.424404    |
| pubxpayments  | io1yftf6xuar26lsaher0qa73d0zc3csm884hjwvh | 1680          | 8366.464792    | 800              | 10846.46479    |
| raketat8      | io1sn9jgmfglhz35fnn9vgawfway4jqm3p3zfh9vu | 0             | 14.32771743    | 0                | 14.32771743    |
| ratels        | io1glapuxr9f77vy9vs3ca0wyg9vyfrexr3ha8qt3 | 1776          | 3122.560725    | 800              | 5698.560725    |
| rockx         | io10cg4lxph8czzes4gxze3hrwj8fryg7zzy5fjrt | 1712          | 3072.112551    | 800              | 5584.112551    |
| royalland     | io19ngaugnmgcshfsdzk56h6trp9gpsk9gkkl0h3j | 2008          | 6456.348799    | 800              | 9264.348799    |
| satoshi       | io12mgttmfa2ffn9uqvn0yn37f4nz43d248l2ga85 | 864           | 3007.275394    | 800              | 4671.275394    |
| slowmist      | io1xuayersqt4un6mgc3kjaf4au8nykz40g4a82cv | 0             | 1101.875884    | 0                | 1101.875884    |
| snzholding    | io1c73j523xfhmuhsucuygmavg2tzg0jg2nj8u8ya | 0             | 1174.817172    | 0                | 1174.817172    |
| tgb           | io1l2ahdfc0uv2rfhreqkee07x296mlgaagrdnty0 | 0             | 1533.764667    | 0                | 1533.764667    |
| thebottoken#  | io12mgttmfa2ffn9uqvn0yn37f4nz43d248l2ga85 | 0             | 1997.358259    | 0                | 1997.358259    |
| wannodes      | io1kjuludtup293j92kqhnnptge8hpg9lez40mych | 0             | 805.8724957    | 0                | 805.8724957    |
| wetez         | io1nlq8szqykh4ztndf4h8jve65trkqt42e7deusv | 0             | 598.9815814    | 0                | 598.9815814    |
| whales        | io1wl83n3up9w8nedf30lnyxzple0gu5pme0dyrds | 0             | 677.4463203    | 0                | 677.4463203    |
| yvalidator    | io1l9aldx4cc65mlpwu0z32ecp3gfavdu03w6lzed | 1584          | 3492.167358    | 800              | 5876.167358    |
| zhcapital     | io10xggkj5dz40gp84ce4hxn3297eprltys8jpgve | 1200          | 2195.255241    | 800              | 4195.255241    |

For Hermes users, their missing rewards details are shown below:

| Delegate Name | Reward Address                            | Staking Address                           | Block Rewards | Epoch Rewards | Foundation Bonus | Total       |
|---------------|-------------------------------------------|-------------------------------------------|---------------|---------------|------------------|-------------|
| coredev       | io12mgttmfa2ffn9uqvn0yn37f4nz43d248l2ga85 | io16frg0hz9ztxhqkn5e42f2aznnreyy79dmqlsn2 | 1576          | 10747.5005    | 800              | 13123.5005  |
| droute        | io12mgttmfa2ffn9uqvn0yn37f4nz43d248l2ga85 | io1cynay8yqe9h0pu7t9cmqzekxh3uls7aracuka0 | 2008          | 8705.957782   | 800              | 11513.95778 |
| enlightiv     | io12mgttmfa2ffn9uqvn0yn37f4nz43d248l2ga85 | io1un3wf5l3lqz33jd672cd44wtw9lzmx8r0uj3he | 1240          | 7022.071661   | 800              | 9062.071661 |
| gamefantasy#  | io12mgttmfa2ffn9uqvn0yn37f4nz43d248l2ga85 | io1v0drnrdeux43sljwc5cd64ck569s5ap70c66ln | 1336          | 5993.191962   | 800              | 8129.191962 |
| hashquark     | io12mgttmfa2ffn9uqvn0yn37f4nz43d248l2ga85 | io1gxxh3pyhtukkpgxrvau9py42zargu9ya8dfurj | 816           | 3189.457595   | 800              | 4805.457595 |
| hotbit        | io12mgttmfa2ffn9uqvn0yn37f4nz43d248l2ga85 | io167725syqfwrndpgfmwd784jk7cy6jlld0mxa80 | 1440          | 5939.809473   | 800              | 8179.809473 |
| huobiwallet   | io12mgttmfa2ffn9uqvn0yn37f4nz43d248l2ga85 | io15d2e9my5mynlzmcsggx9650dua8p99mzg70krv | 1824          | 6309.005428   | 800              | 8933.005428 |
| iosg          | io12mgttmfa2ffn9uqvn0yn37f4nz43d248l2ga85 | io183v7vftj3e4h76z5f5qpswhnn5737rrwjkhyds | 1584          | 5767.378783   | 800              | 8151.378783 |
| longz         | io12mgttmfa2ffn9uqvn0yn37f4nz43d248l2ga85 | io1gvymyt07p5rz74rk8cdf4mr55cm05vnk4kxx2q | 1576          | 3888.568421   | 800              | 6264.568421 |
| metanyx       | io12mgttmfa2ffn9uqvn0yn37f4nz43d248l2ga85 | io19czfrdyjt67g9tuhmmcjkuh2m9qxzv5nqyve9p | 1480          | 7103.558311   | 800              | 9383.558311 |
| satoshi       | io12mgttmfa2ffn9uqvn0yn37f4nz43d248l2ga85 | io1vfzf34ter3wluhustteuaww3mye3h8emr5aga4 | 864           | 3007.275394   | 800              | 4671.275394 |
| thebottoken#  | io12mgttmfa2ffn9uqvn0yn37f4nz43d248l2ga85 | io1x6mar9hlfkxtcyha379fq7ald0kpmt0d3qlyv0 | 0             | 1997.358259   | 0                | 1997.358259 |

The missing coins have been issued to Hermes delegates:

| Delegate Name | Staking Address                           | Distribution Amount | Distribution Hash                                                |
|---------------|-------------------------------------------|---------------------|------------------------------------------------------------------|
| coredev       | io16frg0hz9ztxhqkn5e42f2aznnreyy79dmqlsn2 | 13123.5005          | 2fafab995028546dabde9666c37aaaa9354412ef80892b78af66c26eb2d9a6a9 |
| droute        | io1cynay8yqe9h0pu7t9cmqzekxh3uls7aracuka0 | 11513.95778         | 1801466b46b86e2ae84a29ca7365dace4d7b9ed9aecb07d5b5b77a254d888cd0 |
| enlightiv     | io1un3wf5l3lqz33jd672cd44wtw9lzmx8r0uj3he | 9062.071661         | ecf65593639e8145f54918c717674f048b37f3e2a6e6f89aa04e77feea5227d5 |
| gamefantasy#  | io1v0drnrdeux43sljwc5cd64ck569s5ap70c66ln | 8129.191962         | b0a80d26bca2e9e65b7ee489e83ae4dc383e4d451e962b88b0a0eec275c2519a |
| hashquark     | io1gxxh3pyhtukkpgxrvau9py42zargu9ya8dfurj | 4805.457595         | 868701e46f65bd6914206eac602d8ae7f8240dc6a1138d848914a0e4321872b8 |
| hotbit        | io167725syqfwrndpgfmwd784jk7cy6jlld0mxa80 | 8179.809473         | 2824b53c062b3d0f95a7509e5d7fb32908e697041d8969fdc922904db0f2b156 |
| huobiwallet   | io15d2e9my5mynlzmcsggx9650dua8p99mzg70krv | 8933.005428         | 72189c990c0119406299a1fdcae1e4a7a87c9bc18009e72ec66e326dcc96c6b6 |
| iosg          | io183v7vftj3e4h76z5f5qpswhnn5737rrwjkhyds | 8151.378783         | c86e1080d057fde626bf1a3e467eb0bebeece34c8039e9cd140927f870251105 |
| longz         | io1gvymyt07p5rz74rk8cdf4mr55cm05vnk4kxx2q | 6264.568421         | f693a6d8e2af349cc0b2e4a2673ffb038a25caa8753e7a0de0a4213925a94c82 |
| metanyx       | io19czfrdyjt67g9tuhmmcjkuh2m9qxzv5nqyve9p | 9383.558311         | a92795467136010f7fc324dae9b1850f86424b06a88bafb418a5e74a9c61f4f0 |
| satoshi       | io1vfzf34ter3wluhustteuaww3mye3h8emr5aga4 | 4671.275394         | 0a951a0637cd8b48b26a1687f9a6bc0c351134dd2f8ff9241f032d803a8313c3 |
| thebottoken#  | io1x6mar9hlfkxtcyha379fq7ald0kpmt0d3qlyv0 | 1997.358259         | 281e2b618341c6a913dea5a277a951c3cb2d4509b273771ab42e3f05192f6812 |

# Impact

The problem was identified by the core dev, and mitigated in a few hours, so that there was no economic damage happened except the missing rewards to all delegates which will be caculated and updated here. 

# What Went Well

- This issue has been identified and throughly fixed within a hour.
- The communication of the core members was effective.

# What Did Not Went Well

- Lack of an alerting mechanism when reward pool has a low balance. 
