---
Rollback ID: 2
Title: contract creation address incompatibility
Author: Dustin Xie <dustin.xie@iotex.io>
Rollback height: 8638993
Happened: 2021-05-08
---

# Abstract
With release v1.2.0, testnet cannot commit block 8638994.

# Root-cause
v1.2.0 has a new feature "web3js compatibility", which allows our chain to
process transactions sent in web3js format.

To be compatible with the web3js protocol, the contract creation will need to
use the sender's pending nonce (instead of confirmed nonce as in the current
codebase) to calculate the new contract's address. As a result, the resulting
contract's address will change.

The first such transaction happened on block height 8638994, causing that block
not able to be committed with v1.2.0 release code.   

# Solution
The testnet DB was rolled-back to height 8638993. This clears all earlier
incompatible transactions and after that, it continues to produce new blocks
starting at height 8638994.

# Impact
Testnet blocks after 8638994 are cleared off the chain, no other direct impact
to testnet funds, stability, etc.
